##############################################################################
#
# Copyright (c) 2004 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""permissions

much of file is copied and modifed from CMFCore/CMFCorePermissions.py

$Id: permissions.py,v 1.1.1.1 2004/10/10 23:37:07 poster Exp $
"""

import Products
from AccessControl import Permissions
from AccessControl.Permission import _registeredPermissions
from AccessControl.Permission import pname
from Globals import ApplicationDefaultPermissions

# General Zope permissions
View = Permissions.view
AccessContentsInformation = Permissions.access_contents_information
DeleteObjects = Permissions.delete_objects
UndoChanges = Permissions.undo_changes
ChangePermissions = Permissions.change_permissions
ViewManagementScreens = Permissions.view_management_screens
ManageProperties = Permissions.manage_properties
FTPAccess = Permissions.ftp_access

MakeAsynchronousApplicationCalls = "Make asynchronous application calls"
MakeAsynchronousSessionCalls = "Make asynchronous session calls"
ModifyDeferred = "Modify deferred"

# copied from CMF
def setDefaultRoles(permission, roles):
    '''
    Sets the defaults roles for a permission.
    '''
    # XXX This ought to be in AccessControl.SecurityInfo.
    registered = _registeredPermissions
    if not registered.has_key(permission):
        registered[permission] = 1
        Products.__ac_permissions__=(
            Products.__ac_permissions__+((permission,(),roles),))
        mangled = pname(permission)
        setattr(ApplicationDefaultPermissions, mangled, roles)

# Note that we can only use the default Zope roles in calls to
# setDefaultRoles().  The default Zope roles are:
# Anonymous, Manager, and Owner.

setDefaultRoles(MakeAsynchronousSessionCalls, 
                ('Anonymous', 'Manager',))
setDefaultRoles(MakeAsynchronousApplicationCalls, 
                ('Manager',))
setDefaultRoles(ModifyDeferred, 
                ('Owner', 'Manager',))