##############################################################################
#
# Copyright (c) 2004 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""test bforests

$Id: test_bforests.py,v 1.1.1.1 2004/10/10 23:37:13 poster Exp $
"""

import unittest
from Products.zasync.bforests import IOBForest, OIBForest, OOBForest, IIBForest
from Products.zasync.tests.zopetestutils import DocFileSuite, \
    StringGenerator, NumberGenerator

def test_suite():
    suite = unittest.TestSuite()
    numgen = iter(NumberGenerator()).next
    strgen = iter(StringGenerator()).next
    suite.addTest(
        DocFileSuite(
            '../bforests.txt', 
            BForest=IOBForest, KeyGenerator=numgen, ValueGenerator=strgen))
    suite.addTest(
        DocFileSuite(
            '../bforests.txt', 
            BForest=OIBForest, KeyGenerator=strgen, ValueGenerator=numgen))
    suite.addTest(
        DocFileSuite(
            '../bforests.txt', 
            BForest=IIBForest, KeyGenerator=numgen, ValueGenerator=numgen))
    suite.addTest(
        DocFileSuite(
            '../bforests.txt', 
            BForest=OOBForest, KeyGenerator=strgen, ValueGenerator=strgen))
    return suite

if __name__ == '__main__': 
    import unittest
    unittest.main(defaultTest='test_suite')
